<?php
#######################################
## (inv) Awards #######################
#######################################
## Author:  Alec Carpenter
## Website: http://www.invisionenvy.com
#######################################
##                                ADMIN
## Module:  AWARDS
## Section: AWARD
#######################################
## VERSION: 2.1.0
#######################################

if(!defined('IN_ACP'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

class admin_awards_awards_award extends ipsCommand
{
	function doExecute(ipsRegistry $registry) 
	{
		require(IPS_ROOT_PATH . "applications_addon/other/awards/applicationData.php");
		
		switch($this->request['do'])
		{
			case "give":
				$this->give();
				break;
			case "remove":
				$this->remove();
				break;
			case "delete":
				$this->delete();
				break;
			case "user":
				$this->user();
				break;
			case "search":
				$this->search();
				break;
			default:
				$this->main();
				break;
		}
		
		$this->registry->getClass('output')->sendOutput();
	}
	
	function main()
	{
		# Title
		$this->registry->getClass('output')->html_main .= "
		<div class='section_title'>
		  <h2>User's Awards Management</h2>
	    </div>";
		
		
		# The rest....
		$this->registry->getClass('output')->html_main .= "
		<form name='userSearch' method='post' action='{$this->settings['base_url']}module=awards&section=award&do=search'>
		<div class='acp-box'>
 		  <h3>Search for User</h3>
		  <div class='tablerow1' style='padding:10px;' align='center'>
		  	Enter the display name of an user below to manage their awards. Leave blank to retrieve all members.<br />
			<br />
			<input type='text' name='query' size='35' />
		  </div>
		  <div class='acp-actionbar' align='center'>
		    <input type='submit' value=' Search ' class='realbutton' />
		  </div>
		</div>
		</form>";
	}
	
	function search()
	{
		urldecode($this->request['query']);
			
		# Get members
		$this->DB->build(array(
								'select' => '*',
								'from'   => 'members',
								'where'  => "members_display_name LIKE '%{$this->request['query']}%'",
		));
		
		$this->DB->execute();
		
		$num = $this->DB->getTotalRows();
		
		# Did we get any?
		if(!$num)
		{
			$this->registry->getClass('output')->html_main .= "
			<div class='information-box' style='margin-bottom:15px;'>
			  <h4><img src='http://www.invisionenvy.com/forums/admin/skin_cp/_newimages/icons/bullet_error.png' /> No Results!</h4>
			  Your search has not returned any results.
			</div>";
			
			$this->main();
			
			return;
		}
		
		# Is there just one
		if($num === 1)
		{
			$m = $this->DB->fetch();
			
			$this->registry->output->redirect($this->settings['base_url'] . 'module=awards&section=award&do=user&id=' . $m['member_id'], "Search Complete", 1);
		}
		
		# Create the results
		$n = 1;
		while($m = $this->DB->fetch())
		{
			if($n&1)
			{
				$row = "tablerow1";
			}
			else
			{
				$row = "tablerow2";
			}
			
			$rows .= "
			<div class='{$row}' style='padding:10px;'><a href='{$this->settings['base_url']}module=awards&section=award&do=user&id={$m['member_id']}&returnQuery={$this->request['query']}'>{$m['members_display_name']}</a></div>";
			
			$n++;
		}
		
		# Title
		$this->registry->getClass('output')->html_main .= "
		<div class='section_title'>
		  <h2>User's Awards Management</h2>
	    </div>";
		
		# Show results
		$this->registry->getClass('output')->html_main .= "
		<div class='acp-box'>
 		  <h3>Search Results for: {$this->request['query']}</h3>
		  {$rows}
		</div>";
	}
	
	function user()
	{
		# Get the member data
		$currentMember = ipsRegistry::instance()->member()->fetchMemberData();
		$editingMember = IPSMember::load($this->request['id']);
		
		# Make sure it's all good...
		if(!$editingMember['member_id'])
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$returnQuery = urlencode($this->request['returnQuery']);
		
		if(!$returnQuery)
		{
			$returnURL = $this->settings['base_url'] . "module=awards&section=award";
			$text      = "Search Again";
		}
		else
		{
			$returnURL = $this->settings['base_url'] . "module=awards&section=award&do=search&query=" . $returnQuery;
			$text      = "Return to Results";
		}
		
		# Title
		$this->registry->getClass('output')->html_main .= "
		<div class='section_title'>
		  <h2>User's Awards Management</h2>
		  <ul class='context_menu'>
		    <li>
			  <a href='{$returnURL}'>{$text}</a>
		    </li>
		  </ul>
	    </div>";
		
		# See if we can award!
		$canAward = 1;
		
		if(!$this->settings['awd_self_awarding'])
		{
			if($currentMember['member_id'] == $editingMember['member_id'] && $currentMember['member_id'] != SYSTEM_ROOT_ID)
			{
				$canAward = 0;
			}
			elseif($currentMember['member_id'] == $editingMember['member_id'] && $currentMember['member_id'] == SYSTEM_ROOT_ID)
			{
				# we're good!
			}
			elseif($currentMember['member_id'] != $editingMember['member_id'])
			{
				# we're good!
			}
		}
		else
		{
			# we're good!
		}
		
		# Get the awards
		$this->DB->build(array(
								'select' => '*',
								'from'   => 'inv_awards',
		));
		
		$this->DB->execute();
		
		# Are there any awards
		if($this->DB->getTotalRows() && $canAward)
		{
			while($a = $this->DB->fetch())
			{
				if(strpos($m['awards'], $a['id'] . ",") === false)
				{
					$options .= "<option value='{$a['id']}'>{$a['name']}</option>";
				}
			}
			
			if($options)
			{
				# Show the "give award" box
				$this->registry->getClass('output')->html_main .= "
				<form name='giveAward' method='post' action='{$this->settings['base_url']}module=awards&section=award&do=give&mid={$editingMember['member_id']}'>
				<div class='acp-box'>
				  <h3>Give {$editingMember['members_display_name']} an Award</h3>
				  <table with='100%' class='double_pad'>
					<tr>
					  <td class='tablerow1' width='35%'><strong>Choose an Award</strong></td>
					  <td class='tablerow2'><select name='awardToGive'><option selected disabled>Choose an Award</option>{$options}</select></td>
					</tr>
					<tr>
					  <td class='tablerow1'>
						<strong>Notes</strong><br />
						<div class='desctext'>A brief description for why you are giving this award.</div>
					  </td>
					  <td class='tablerow2'>
						<textarea name='notes' rows='4' cols='25'></textarea>
					  </td>
					</tr>
				  </table>
				  <div class='acp-actionbar'>
					  <input type='submit' value=' Give Award ' class='realbutton' />
					</div>
				</div>
				</form>";
			}
		}
		
		# Prepare the awards this user has for output
		$this->DB->build(array(
							   'select'   => 'aa.row_id,aa.notes,aa.is_active',
							   'from'     => array('inv_awards_awarded' => 'aa'),
							   'add_join' => array(
							   					   0 => array(
												   			  'select' => 'a.id,a.name,a.icon',
												 			  'from'   => array('inv_awards' => 'a'),
												  			  'where'  => 'a.id = aa.award_id',
														),
							   ),
							   'where'    => 'user_id = ' . $editingMember['member_id'],
		));
		
		$this->DB->execute();
		
		if($this->DB->getTotalRows())
		{
			while($a = $this->DB->fetch())
			{
				# Includes the editing feature for the notes
				$notes = $a['notes'] . " <span style='display:none;' id='edit_{$a['row_id']}'><a href='javascript: editNotes({$a['row_id']}, 1, 0);'><img src='{$this->settings['skin_acp_url']}/_newimages/icons/pencil.png' alt='Edit Notes' title='Edit Notes' border='0' /></a></span>";
				
				# Creates the array for the javascript
				$notesArray .= "notesArray[{$a['row_id']}] = \"" . addslashes($a['notes']) . "\";";
				
				if($a['is_active'])
				{
					$currentRows .= "
					<tr onmouseover='javascript: showEditBtn({$a['row_id']}, 1);' onmouseout='javascript: showEditBtn({$a['row_id']}, 0);'>
					  <td align='center'><img src='" . UPLOAD_URL . "{$a['icon']}' /></td>
					  <td>{$a['name']}</td>
					  <td id='notes_td_{$a['row_id']}'>{$notes}</td>
					  <td align='center' width='15%'>
					    <img class='ipbmenu' id='menu_{$a['row_id']}' src='{$this->settings['skin_acp_url']}/_newimages/menu_open.png' alt='Options' />
				        <ul class='acp-menu' id='menu_{$a['row_id']}_menucontent'>
					      <li class='icon delete'><a href='{$this->settings['base_url']}module=awards&section=award&do=remove&id={$a['row_id']}&active=0'>Remove Award</a></li>
					      <li class='icon delete'><a href='javascript: deleteAward({$a['row_id']});'>Delete Award</a></li>
					    </ul>
					  </td>
					</tr>";
				}
				else
				{
					$removedRows .= "
					<tr onmouseover='javascript: showEditBtn({$a['row_id']}, 1);' onmouseout='javascript: showEditBtn({$a['row_id']}, 0);'>
					  <td align='center'><img src='" . UPLOAD_URL . "{$a['icon']}' /></td>
					  <td>{$a['name']}</td>
					  <td id='notes_td_{$a['row_id']}'>{$notes}</td>
					  <td align='center'>
					    <img class='ipbmenu' id='menu_{$a['row_id']}' src='{$this->settings['skin_acp_url']}/_newimages/menu_open.png' alt='Options' />
				        <ul class='acp-menu' id='menu_{$a['row_id']}_menucontent'>
					      <li class='icon add'><a href='{$this->settings['base_url']}module=awards&section=award&do=remove&id={$a['row_id']}&active=1'>Re-Add Award</a></li>
					      <li class='icon delete'><a href='javascript: deleteAward({$a['row_id']});'>Delete Award</a></li>
					    </ul>
					  </td>
					</tr>";
				}
			}
		}
		
		# Check to see if there are rows for both current and removed awards
		if(!$currentRows)
		{
			$currentRows = "
			<tr>
			  <td colspan='4' align='center'>{$m['members_display_name']} does not have any \"current\" awards</td>
			</tr>";
		}
		
		if(!$removedRows)
		{
			$removedRows = "
			<tr>
			  <td colspan='4' align='center'>{$m['members_display_name']} does not have any \"removed\" awards</td>
			</tr>";
		}
		
		$this->registry->getClass('output')->html_main .= "
		<br />
		<script type='text/javascript'>
		var conf;
		var InEditMode = 0;
		var notesArray = [];
		{$notesArray}
		
		function deleteAward(aid)
		{
			conf = confirm('Are you sure you want to PERMANENTLY DELETE this award?');
			
			if(conf)
			{
				window.location = '" . html_entity_decode($this->settings['base_url'], ENT_QUOTES) . "module=awards&section=award&do=delete&id=' + aid;
			}
		}
		
		function showEditBtn(id, status)
		{
			if(!InEditMode)
			{
				var btnSpan = document.getElementById('edit_' + id);
				
				if(status)
				{
					btnSpan.style.display = 'block';
				}
				else
				{
					btnSpan.style.display = 'none';
				}
			}
		}
		
		function editNotes(row, status, cancel)
		{
			if(!InEditMode || cancel || !status)
			{
				var editTD = document.getElementById('notes_td_' + row);
				InEditMode = 1;
				
				if(status)
				{
					editTD.innerHTML = '<textarea id=\"edit_notes_' + row + '\" rows=\"5\" cols=\"40\">' + notesArray[row] + '</textarea> <a href=\"javascript: saveNotes(' + row + ');\"><img src=\"{$this->settings['skin_acp_url']}/_newimages/icons/disk.png\" alt=\"Save Notes\" title=\"Save Notes\" border=\"0\" /></a> <a href=\"javascript: editNotes(' + row + ', 0, 1);\"><img src=\"{$this->settings['skin_acp_url']}/_newimages/icons/delete.png\" alt=\"Cancel\" title=\"Cancel\" border=\"0\" /></a>';
				}
				else
				{
					if(cancel)
					{
						conf = confirm('Are you sure that you would like to cancel, any changes will be lost.');
					}
					else
					{
						conf = 1;
					}
					
					if(conf)
					{
						editTD.innerHTML = notesArray[row] + \" <span style='display:none;' id='edit_\" + row + \"'><a href='javascript: editNotes(\" + row + \", 1, 0);'><img src='{$this->settings['skin_acp_url']}/_newimages/icons/pencil.png' alt='Edit Notes' title='Edit Notes' border='0' /></a></span>\";
						
						InEditMode = 0;
					}
				}
			}
		}
		
		function saveNotes(row)
		{
			var notesValue = document.getElementById('edit_notes_' + row).value;
			var editTD     = document.getElementById('notes_td_' + row);
			
			editTD.innerHTML = \"<img src='{$this->settings['skin_acp_url']}/_newimages/loading.gif' alt='Loading...' title='Loading...' border='0' />\";
			
			new Ajax.Request('" . str_replace("&amp;", "&", "{$this->settings['base_url']}module=ajax&section=award&do=saveNotes&") . "row_id=' + row + '&secure_key=' + ipb.vars['md5_hash'],
						{
							method: 'post',
							parameters: {
								         'row_id': row,
										 'notes': notesValue.encodeParam()
							},
							onSuccess: function(t)
							{
								if(t.responseText == 1)
								{
									notesArray[row] = notesValue;
									editTD.innerHTML = \"<span style='color:green;'><strong>Notes Saved!</strong></span>\";
									setTimeout('editNotes(' + row + ', 0, 0)', 1500);
								}
								else
								{
									alert('An error has occurred');
								}
							},
						}
					);
		}
		
		document.observe('dom:loaded',function() 
		{
			ipbAcpTabStrips.register('tab_awards');
		});
		</script>
		<ul id='tab_awards' class='tab_bar no_title'>
	      <li id='tabtab-AWARDS|1' class=''>Current Awards</li>
		  <li id='tabtab-AWARDS|2' class=''>Removed Awards</li>
		</ul>
		<div class='acp-box'>
		  <div id='tabpane-AWARDS|1'>
		    <table with='100%' class='alternate_rows double_pad'>
		      <tr>
				<th width='15%'><div align='center'>Award Image</div></th>
				<th width='25%'>Award Title</th>
				<th width='30%'>Notes</th>
				<th width='15%'>&nbsp;</th>
			  </tr>
			  {$currentRows}
			</table>
		  </div>
		  <div id='tabpane-AWARDS|2'>
		    <table with='100%' class='alternate_rows double_pad'>
		      <tr>
				<th width='15%'><div align='center'>Award Image</div></th>
				<th width='25%'>Award Title</th>
				<th width='30%'>Notes</th>
				<th width='15%'>&nbsp;</th>
			  </tr>
			  {$removedRows}
			</table>
		  </div>
		</div>";
	}
	
	function remove()
	{
		# Get award
		$this->DB->build(array(
								'select' => '*',
								'from'   => 'inv_awards_awarded',
								'where'  => "row_id = {$this->request['id']}",
		));
		
		$this->DB->execute();
		
		# Make sure it's all good...
		if(!$this->DB->getTotalRows())
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$a = $this->DB->fetch();
		
		$this->DB->update('inv_awards_awarded', array('is_active' => $this->request['active']), 'row_id=' . $a['row_id']);
		
		# Redirect
		$this->registry->output->redirect($this->settings['base_url'] . 'module=awards&section=award&do=user&id=' . $a['user_id'], "Award Status Updated", 1);
	}
	
	function delete()
	{
		# Get award
		$this->DB->build(array(
								'select' => '*',
								'from'   => 'inv_awards_awarded',
								'where'  => "row_id = {$this->request['id']}",
		));
		
		$this->DB->execute();
		
		# Make sure it's all good...
		if(!$this->DB->getTotalRows())
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$a = $this->DB->fetch();
		
		$this->DB->delete('inv_awards_awarded', 'row_id = ' . $a['row_id']);
		
		# Redirect
		$this->registry->output->redirect($this->settings['base_url'] . 'module=awards&section=award&do=user&id=' . $a['user_id'], "Award Deleted", 1);
	}
	
	function give()
	{
		# Get member
		$m = IPSMember::load($this->request['mid']);
		
		# Make sure it's all good...
		if(!$m['member_id'])
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		# Update the user's awards
		$INSERT = array(
						'award_id' => $_POST['awardToGive'],
						'user_id'  => $m['member_id'],
						'notes'    => $_POST['notes'],
						'date'     => time(),
		);
		$this->DB->insert('inv_awards_awarded', $INSERT);
			
		$this->registry->output->redirect($this->settings['base_url'] . 'module=awards&section=award&do=user&id=' . $m['member_id'], "Award Given", 1);
	}
}
?>