<?php
#######################################
## (inv) Awards #######################
#######################################
## Author:  Alec Carpenter
## Website: http://www.invisionenvy.com
#######################################
##                                ADMIN
## Module:  AWARDS
## Section: MANAGE
#######################################
## VERSION: 2.1.0
#######################################

if(!defined('IN_ACP'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

class admin_awards_awards_manage extends ipsCommand
{
	public function doExecute(ipsRegistry $registry) 
	{
		require(IPS_ROOT_PATH . "applications_addon/other/awards/applicationData.php");
		
		switch($this->request['do'])
		{
			case "delete":
				$this->deleteAward();
				break;
			case "add":
				$this->addAward();
				break;
			case "edit":
				$this->editAward();
				break;
			default:
				$this->main();
				break;
		}
		
		$this->registry->getClass('output')->sendOutput();
	}
	
	public function addHeader()
	{
		$this->registry->getClass('output')->html_main = "
		<div class='section_title'>
		  <h2>Awards Management</h2>
		  <ul class='context_menu'>
		    <li>
			  <a href='{$this->settings['base_url']}module=awards&section=manage&do=add'><img src='{$this->settings['skin_acp_url']}/_newimages/icons/add.png' alt='' />Add New Award</a>
		    </li>
		  </ul>
	    </div>";
	}
	
	public function main()
	{
		# Get awards to show
		$this->DB->build(array(
								'select'   => '*',
								'from'     => 'inv_awards',
								'order by' => 'id ASC',
		));
		
		$this->DB->execute();
		
		# Verify we have awards
		if(!$this->DB->getTotalRows())
		{
			$rows = "
			<tr>
			  <td colspan='2' class='tablerow1' align='center'>You haven't added any awards yet.</td>
			</tr>";
		}
		else
		{
			$num = 1;
			
			while($a = $this->DB->fetch())
			{
				if($num&1)
				{
					$trn = 1;
				}
				else
				{
					$trn = 2;
				}
				
				$rows .= "
				<tr>
				  <td class='tablerow{$trn}' align='center'><img src='{$this->settings['upload_url']}/awards/{$a['icon']}' /></td>
			  	  <td class='tablerow{$trn}' width='75%;'>
				    <strong>{$a['name']}</strong>
					<div class='desctext'>{$a['desc']}</div>
				  </td>
				  <td class='tablerow{$trn}' width='10%'>
				    <img class='ipbmenu' id='menu_{$a['id']}' src='{$this->settings['skin_acp_url']}/_newimages/menu_open.png' alt='Options' />
				    <ul class='acp-menu' id='menu_{$a['id']}_menucontent'>
					  <li class='icon edit'><a href='{$this->settings['base_url']}module=awards&section=manage&do=edit&id={$a['id']}'>Edit Award</a></li>
					  <li class='icon delete'><a href='{$this->settings['base_url']}module=awards&section=manage&do=delete&id={$a['id']}'>Delete Award</a></li>
					</ul>
				  </td>
				</tr>";
				
				$num++;
			}
		}
		
		$this->addHeader();
		
		$this->registry->getClass('output')->html_main .= "
		<div class='acp-box'>
 		  <h3>Current Awards</h3>
	      <table width='100%' class='double_pad'>
		    {$rows}
		  </table>
		</div>";
	}
	
	public function deleteAward()
	{
		# Get the award to show
		$this->DB->build(array(
								'select'   => '*',
								'from'     => 'inv_awards',
								'where' => "id = {$this->request['id']}",
		));
		
		$this->DB->execute();
		$num = $this->DB->getTotalRows();
		
		# Make sure this award exists
		if(!$num || $num > 1)
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$a = $this->DB->fetch();
		
		# Veryify the user didn't skip a step
		if($this->request['continue'])
		{
			if($_POST['deleteAward'] == $a['id'])
			{
				$this->DB->delete('inv_awards_awarded', 'award_id="' . $a['id'] . '"');
				$this->DB->delete('inv_awards', 'id=' . $a['id']);
				
				// Redirect....
				$this->registry->output->redirect($this->settings['base_url'], "Award deleted", 1);
			}
			else
			{
				$this->registry->output->showError('Please make sure you are not skipping a step');
			}
		}
		
		$this->registry->getClass('output')->html_main .= "
		<div class='acp-box'>
 		  <h3>Deleting Award: {$a['name']}</h3>
	        <div class='tablerow1' style='padding:10px;'>
			Are you sure that you would like to delete this award, this action cannot be undone.
		  </div>
		  <div class='acp-actionbar'>
		    <form name='deleteAward' method='post' action='{$this->settings['base_url']}module=awards&section=manage&do=delete&id={$this->request['id']}&continue=1'>
			  <input type='hidden' name='deleteAward' value='{$a['id']}' />
			  <input type='submit' value=' Yes, Delete ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}'>Cancel</a></strong>
			</form>
	  	  </div>
        </div>";
	}
	
	public function addAward()
	{
		# Ready to add it?
		if($this->request['continue'])
		{
			$name = $this->request['award_name'];
			$desc = $this->request['award_desc'];
			$icon = $_FILES['award_icon'];
			$uDir = UPLOAD_DIR;
			
			# Did you enter a name
			if(!$name)
			{
				$this->registry->output->showError('You must enter a name for this award');
			}
			
			# Is your icon good?
			if(!$icon['name'] || strpos($icon['type'], "image") === FALSE)
			{
				$this->registry->output->showError('You can only upload images for the icon');
			}
			
			# Just incase! ;)
			if(file_exists($uDir . $icon['name']))
			{
				$icon['name'] = rand(1,9999) . "_" . $icon['name'];
			}
			
			# Check for the directory
			$this->checkUploadDir($uDir);
			
			# Upload the image
			if(!@move_uploaded_file($icon['tmp_name'], $uDir . $icon['name']))
			{
				$this->registry->output->showError('Adding this award has failed, please try again. (a)');
			}
			
			# Run the query
			$this->DB->insert('inv_awards', array(
													'name' => $name,
													'desc' => $desc,
													'icon' => $icon['name'],
			));
			
			# Check the award was added
			$this->DB->build(array(
									'select' => '*',
									'from'   => 'inv_awards',
									'where'  => 'icon = "' . $icon['name'] . '"',
			));
			
			$this->DB->execute();
			
			if(!$this->DB->getTotalRows())
			{
				$this->registry->output->showError('Adding this award has failed, please try again. (b)');
			}
			
			# Redirect
			$this->registry->output->redirect($this->settings['base_url'], "Award added", 1);
		}
		
		$this->registry->getClass('output')->html_main .= "
		<form name='addAward' method='post' action='{$this->settings['base_url']}module=awards&section=manage&do=add&continue=1' enctype='multipart/form-data'>
		<div class='acp-box'>
 		  <h3>Adding Award</h3>
		  <table width='100%' class='double_pad'>
		    <tr>
			  <td class='tablerow1' width='35%'>
			    <strong>Award Name</strong>
				<div class='desctext'>The award will be identified by this</div>
			  </td>
			  <td class='tablerow1'><input type='text' name='award_name' size='35' value='{$this->request['award_name']}' /></td>
			</tr>
			<tr>
			  <td class='tablerow2'>
			    <strong>Award Description</strong>
				<div class='desctext'>Brief description about why this award is given out.</div>
			  </td>
			  <td class='tablerow2'>
			    <textarea name='award_desc' rows='4' cols='30'>{$this->request['award_desc']}</textarea>
			  </td>
			</tr>
			<tr>
			  <td class='tablerow1'>
			    <strong>Award Icon</strong>
				<div class='desctext'>This is the image representation for this award. It should be about 40x40 pixels, only upload image files.</div>
			  </td>
			  <td class='tablerow1'>
			    <input type='file' name='award_icon' />
			  </td>
			</tr>
		  </table>
		  <div class='acp-actionbar'>
		    <input type='submit' value=' Add Award ' class='realbutton' />
	  	  </div>
		</div>
		</form>";
	}
	
	public function editAward()
	{
		# Check the award was added
		$this->DB->build(array(
								'select' => '*',
								'from'   => 'inv_awards',
								'where'  => 'id = ' . $this->request['id'],
		));
		
		$this->DB->execute();
		
		if(!$this->DB->getTotalRows())
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$a = $this->DB->fetch();
		
		# Ready to add it?
		if($this->request['continue'])
		{
			$name = $this->request['award_name'];
			$desc = $this->request['award_desc'];
			$icon = $_FILES['award_icon'];
			$uDir = UPLOAD_DIR;
			
			# Did you enter a name
			if(!$name)
			{
				$this->registry->output->showError('You must enter a name for this award');
			}
			
			$saveIcon = FALSE;
			
			if($icon['name'])
			{
				# Is your icon good?
				if(strpos($icon['type'], "image") === FALSE)
				{
					$this->registry->output->showError('You can only upload images for the icon');
				}
				
				# Just incase! ;)
				if(file_exists($uDir . $icon['name']))
				{
					$icon['name'] = rand(1,9999) . "_" . $icon['name'];
				}
				
				# Check for the directory
				$this->checkUploadDir($uDir);
				
				# Upload the image
				if(!@move_uploaded_file($icon['tmp_name'], $uDir . $icon['name']))
				{
					$this->registry->output->showError('Adding this award has failed, please try again. (a)');
				}
				
				# Delete the old icon
				if($a['icon'])
				{
					unlink($uDir . $a['icon']);
				}
			}
			else
			{
				$icon['name'] = $a['icon'];
			}
			
			# Run the query
			$this->DB->update('inv_awards', array('`name`' => $name, '`desc`' => $desc, '`icon`' => $icon['name']), "id = {$a['id']}");
			
			# Redirect
			$this->registry->output->redirect($this->settings['base_url'], "Changes Saved", 1);
		}
		
		$this->registry->getClass('output')->html_main .= "
		<form name='editAward' method='post' action='{$this->settings['base_url']}module=awards&section=manage&do=edit&id={$a['id']}&continue=1' enctype='multipart/form-data'>
		<div class='acp-box'>
 		  <h3>Editing Award: {$a['name']}</h3>
		  <table width='100%' class='double_pad'>
		    <tr>
			  <td class='tablerow1' width='35%'>
			    <strong>Award Name</strong>
				<div class='desctext'>The award will be identified by this</div>
			  </td>
			  <td class='tablerow1'><input type='text' name='award_name' size='35' value='{$a['name']}' /></td>
			</tr>
			<tr>
			  <td class='tablerow2'>
			    <strong>Award Description</strong>
				<div class='desctext'>Brief description about why this award is given out.</div>
			  </td>
			  <td class='tablerow2'>
			    <textarea name='award_desc' rows='4' cols='30'>{$a['desc']}</textarea>
			  </td>
			</tr>
			<tr>
			  <td class='tablerow1'>
			    <strong>Award Icon</strong>
				<div class='desctext'>This is the image representation for this award. It should be about 40x40 pixels, only upload image files.</div>
			  </td>
			  <td class='tablerow1'>
			    <span style='color:red; font-weight:bold;'>Leave this blank to not change the award's icon!!!</span><br />
			    <input type='file' name='award_icon' />
			  </td>
			</tr>
		  </table>
		  <div class='acp-actionbar'>
		    <input type='submit' value=' Save Changes ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}'>Cancel</a></strong>
	  	  </div>
		</div>
		</form>";
	}
	
	public function checkUploadDir($dir)
	{
		if(!is_dir($dir))
		{
			mkdir($dir);
		}
	}
}
?>