<?php
#######################################
## (inv) Awards #######################
#######################################
## Author:  Alec Carpenter
## Website: http://www.invisionenvy.com
#######################################
##                               PUBLIC
## Module:  AWARDS
## Section: AWARDS
#######################################
## VERSION: 2.1.0
#######################################

if (!defined('IN_IPB'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class public_awards_awards_awards extends ipsCommand
{
	public function doExecute(ipsRegistry $registry)
	{
		require(IPS_ROOT_PATH . "applications_addon/other/awards/applicationData.php");
		
		# Get the language
		$this->lang->loadLanguageFile(array("public_awards"), 'awards');
		
		# Title and navigation
		$this->registry->output->setTitle($this->lang->words['title']);
		$this->registry->output->addNavigation($this->lang->words['title'], "app=awards&module=awards&section=awards");
		
		switch($this->request['do'])
		{
			default:
				$this->showListings();
				break;
		}
		
		# Copyright information - do not remove
		$this->registry->getClass('output')->addContent("<div align='right' style='font-size:10px; margin-top:10px; margin-bottom:-30px;'>(inv) Awards " . AWARDS_VERSION . ", by <a href='http://www.invisionenvy.com/forums/' target='_blank'>Alec Carpenter</a></div>");
		
		# Finish it off
        $this->registry->output->sendOutput();
	}
	
	function showListings()
	{
		# Does this user have permission
		if(!$this->verifyPermission())
		{
			$this->registry->getClass('output')->showError($this->lang->words['error_no_permission'], "11A3", false);
		}
		
		# Is this page enabled?
		if(!$this->settings['awd_listings_status'])
		{
			# Is there a custom message to show?
			if($this->settings['awd_listings_disabled_msg'])
			{
				$msg = $this->settings['awd_listings_disabled_msg'];
			}
			else
			{
				$msg = $this->lang->words['error_listings_disabled'];
			}
			
			$this->registry->getClass('output')->showError($msg, "11A1", false);
		}
		
		# Get awards to show
		$this->DB->build(array(
								'select'   => '*',
								'from'     => 'inv_awards',
								'order by' => 'id ASC',
		));
		
		$this->DB->execute();
		
		# Verify we have awards
		if(!$this->DB->getTotalRows())
		{
			$this->registry->getClass('output')->showError($this->lang->words['error_no_awards'], "10A2", false);
		}
		
		# Get'em ready!
		while($a = $this->DB->fetch())
		{
			$rows .= $this->registry->output->getTemplate('awards')->listings_row($a, $this->settings['upload_url']);
		}
		
		# AJAX URL
		$output .= $this->registry->output->getTemplate('awards')->listings_container($rows);
		
		# Put it out there!
		$this->registry->getClass('output')->addContent($output);
	}
	
	function verifyPermission()
	{
		$perms = $this->settings['awds_permissions'];
		$exp   = explode(",", $perms);
		
		$p = FALSE;
		foreach($exp as $gid)
		{
			if($this->memberData['g_id'] == $gid)
			{
				$p = TRUE;
			}
		}
		
		return $p;
	}
}
?>